SystemOrganization addCategory: #AppleScriptProgrammer!

Object subclass: #DependencySorter
	instanceVariableNames: 'sortedStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!DependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 20:30'!
commitInsert: anObject 

	self sortedStream nextPut: anObject! !

!DependencySorter methodsFor: 'defaults' stamp: 'hjo 6/6/2010 18:33'!
defaultSortedStream

	^WriteStream on: Array new! !

!DependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 21:48'!
insert: anObject

	(self shouldSkipInserting: anObject) ifTrue: [^self].
	(self sortedStreamIncludes: anObject) ifFalse: [ 
		(self prerequisitesOf:anObject) do: [:prerequisite | self insert: prerequisite ]].
	self commitInsert: anObject! !

!DependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 19:10'!
prerequisitesOf: anObject

	"Answer a collection of objects that should be inserted before anObject."
	^self subclassResponsibility! !

!DependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 19:11'!
shouldSkipInserting: anObject

	"Subclass should implement this method. Dont forget to super call this method."
	^self sortedStreamIncludes: anObject! !

!DependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 19:12'!
sortedCollection

	^self sortedStream contents! !

!DependencySorter methodsFor: 'accessing' stamp: 'hjo 6/6/2010 18:28'!
sortedStream

	^sortedStream setDefault: #defaultSortedStream for: self withSetter: #sortedStream:! !

!DependencySorter methodsFor: 'accessing' stamp: 'hjo 6/6/2010 18:28'!
sortedStream: anObject
		
	sortedStream := anObject! !

!DependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 19:02'!
sortedStreamIncludes: anObject

	^self sortedStream contents includes: anObject! !

DependencySorter subclass: #LocalMethodDependencySorter
	instanceVariableNames: 'mainClass selectorsOfMainClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!LocalMethodDependencySorter methodsFor: 'defaults' stamp: 'hjo 6/8/2010 00:26'!
defaultSelectorsOfMainClass

	^mainClass selectors! !

!LocalMethodDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/8/2010 00:26'!
insertAll

	self selectorsOfMainClass do: [:each| self insert: each]! !

!LocalMethodDependencySorter methodsFor: 'accessing' stamp: 'hjo 6/6/2010 21:16'!
mainClass

	^mainClass! !

!LocalMethodDependencySorter methodsFor: 'accessing' stamp: 'hjo 6/8/2010 00:27'!
mainClass: aClass

	mainClass := aClass.
	self selectorsOfMainClass: nil! !

!LocalMethodDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 21:48'!
prerequisitesOf: aSymbol

	^((mainClass compiledMethodAt: aSymbol) messages) copyWithout: aSymbol! !

!LocalMethodDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 23:14'!
printSortedMethodSourceOn: aMultiByteFileStream 

	self sortedCollection do: [:each| 
		aMultiByteFileStream nextPutAll: 
			(mainClass compiledMethodAt: each) getSource.
		aMultiByteFileStream cr; cr; cr; cr; cr
		]! !

!LocalMethodDependencySorter methodsFor: 'accessing' stamp: 'hjo 6/8/2010 00:25'!
selectorsOfMainClass

	^selectorsOfMainClass setDefault: #defaultSelectorsOfMainClass for: self withSetter: #selectorsOfMainClass:! !

!LocalMethodDependencySorter methodsFor: 'accessing' stamp: 'hjo 6/8/2010 00:25'!
selectorsOfMainClass: anObject
		
	selectorsOfMainClass := anObject! !

!LocalMethodDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/8/2010 00:28'!
shouldSkipInserting: aSymbol

	^(self selectorsOfMainClass includes: aSymbol) not! !

!LocalMethodDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/7/2010 21:09'!
sortedMethodSource

	| writeStream |
	writeStream := WriteStream on: String new.
	self printSortedMethodSourceOn: writeStream.
	^writeStream contents! !

DependencySorter subclass: #OmniOutlinerDependencySorter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!OmniOutlinerDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 18:26'!
prerequisitesOf: aClass 

	^Array with: aClass superclass! !

!OmniOutlinerDependencySorter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 19:07'!
shouldSkipInserting: aClass

	^aClass isNil or: [ aClass isMeta ] or: [ super shouldSkipInserting: aClass ]! !

Object subclass: #OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter
	instanceVariableNames: 'appleScriptStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AppleScriptProgrammer'!

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 6/16/2009 17:51'!
appleScriptStream

	^appleScriptStream setDefault: #defaultAppleScriptStream for: self withSetter: #appleScriptStream:! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'accessing' stamp: 'hjo 6/16/2009 17:51'!
appleScriptStream: anObject
		
	appleScriptStream := anObject! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'defaults' stamp: 'hjo 6/16/2009 17:51'!
defaultAppleScriptStream

	^FileStream newFileNamed: 'oo.scpt'! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 6/16/2009 18:05'!
writeClosingContents

	self appleScriptStream nextPutAll:
'	end tell
end tell'.
! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 6/6/2010 22:16'!
writeFile

	| stream dependencySorter |
	self writeOpenningContents.
	
	stream := self appleScriptStream.
	
	dependencySorter := OmniOutlinerDependencySorter new.
	dependencySorter commitInsert: ProtoObject.
	(Smalltalk allClasses copyWithout: ProtoObject) do: [:eachClass| dependencySorter insert: eachClass].
	(dependencySorter sortedCollection copyWithout: ProtoObject) do: [:each|
			stream nextPutAll: 'set St'.
	stream nextPutAll: each name.
	stream nextPutAll: ' to make new row with properties {topic:"'.
	stream nextPutAll: each name.
	stream nextPutAll: '"} at end of children of '.
	stream nextPutAll: (each superclass isNil ifTrue: ['StProtoObject'] ifFalse: ['St' , each superclass name]).
	stream cr.
		].
	
	self writeClosingContents.
	self appleScriptStream close! !

!OmniOutlinerDocumentOfSmalltalkClassHierarchyGeneratingAppleScriptWriter methodsFor: 'as yet unclassified' stamp: 'hjo 6/23/2009 19:50'!
writeOpenningContents

	self appleScriptStream nextPutAll:
'tell application "OmniOutliner"
	
	
	tell (make new document)
		set StProtoObject to make new row with properties {topic:"ProtoObject"} at end
'.
! !
